! TR 15581, sec. 2.2: allocatable arrays as dummy arguments

program f2003_tr15581_1
  implicit none
  real, allocatable :: x(:), y(:)
  call setup (x)
  print *, "Array size:", size (x)
  print *, "Values    :", x
  call roots (y, x)
  print *, "Roots     :", y
  deallocate (x, y)
  call roots (y, x)
  if (allocated (y)) then
     print *, "Error: y is allocated"
  end if

contains

  subroutine setup (array)
    real, allocatable, intent(out) :: array(:)
    integer :: n, i
    n = 4
    allocate (array(n))
    array = (/ (i*i, i=1,n) /)
  end subroutine setup

  subroutine roots (y, x)
    real, allocatable, intent(in)  :: x(:)
    real, allocatable, intent(out) :: y(:)
    if (allocated (x)) then
       allocate (y(size (x)))
       y = sqrt (x)
    end if
  end subroutine roots
end program f2003_tr15581_1
