!-----------------------------------------------------------------------------
! Working:
!
! Intel 11.0.074: ifort -threads -fpp pthread.f90
!                 typedef unsigned long int pthread_t; (Linux 2.6, glibc 2.3) 
! gfortran 4.3.2: gfortran -pthread -xf95-cpp-input pthread.f90
!                 typedef unsigned long int pthread_t; (Linux 2.6, glibc 2.3) 
! NAG 5.2-649:    nagfor -f2003 -thread_safe -fpp pthread.f90
!                 typedef unsigned long int pthread_t; (Linux 2.6, glibc 2.3) 
! IBM xlf 12.1:   xlf2003_r -qsuffix=cpp=f90 pthread.f90
!                 typedef unsigned int pthread_t; (AIX 5.3)
! Failed:
!
! Sun Ceres Fortran 95 8.3 Linux_i386 2008/10/22
! pgf95 8.0-2 64-bit target on x86-64 Linux -tp k8-64e
!
! Remark: 
!
! SuperUX         typedef int32_t pthread_t;
!-----------------------------------------------------------------------------
MODULE pthread

  USE, INTRINSIC :: iso_c_binding

  IMPLICIT NONE

  PRIVATE

  PUBLIC :: pthread_create
  PUBLIC :: pthread_exit

  INTEGER, PARAMETER :: pthread_t_size = 1

  INTERFACE

    INTEGER(c_int) FUNCTION pthread_create(thread, attr, start_routine, arg) BIND(C) 
      IMPORT :: c_int, c_ptr, c_funptr
      TYPE(c_ptr),    VALUE :: thread
      TYPE(c_ptr),    VALUE :: attr
      TYPE(c_funptr), VALUE :: start_routine
      TYPE(c_ptr),    VALUE :: arg 
    END FUNCTION pthread_create

    SUBROUTINE pthread_exit(value_ptr) BIND(c)
      IMPORT :: c_ptr
      TYPE(c_ptr),    VALUE :: value_ptr
    END SUBROUTINE pthread_exit

  END INTERFACE

END MODULE pthread

MODULE start_routine

  USE, INTRINSIC :: iso_c_binding

  USE pthread

  IMPLICIT NONE

  PRIVATE

  PUBLIC :: PrintHello

CONTAINS

  SUBROUTINE PrintHello (ThreadId) BIND(c)

    TYPE(c_ptr), VALUE :: ThreadId

    INTEGER, POINTER :: tid

    CALL c_f_pointer(ThreadId, tid)

    PRINT *, "Hello World! It's me, thread #", tid, "!"

    CALL pthread_exit(c_null_ptr);
    
  END SUBROUTINE PrintHello

END MODULE start_routine

PROGRAM PthreadTest

  USE, INTRINSIC :: iso_c_binding

  USE pthread
  USE start_routine

  IMPLICIT NONE

  INTEGER, PARAMETER :: NumThreads = 5

  TYPE(c_funptr) :: start

  INTEGER(c_long), TARGET :: threads(0:4)

  INTEGER :: rc

  INTEGER :: t
  INTEGER, TARGET :: tid(0:4)

  start = c_funloc(PrintHello)

  DO t = 0, NumThreads-1

    PRINT *, "In main: creating thread ", t

    tid(t) = t
    rc = pthread_create(c_loc(threads(t)), c_null_ptr, start, c_loc(tid(t)));
    IF (rc /= 0) THEN
      PRINT *, "ERROR; return code from pthread_create() is ", rc
      STOP
    ENDIF

  ENDDO

  CALL pthread_exit(c_null_ptr);

END PROGRAM PthreadTest
